networks:
  nginx-bridge: # Change to network you plan to use
    external: true

services:
  next-app:
    build:
      context: ../
      dockerfile: ./docker/Dockerfile
    image: ${NEXT_CONTAINER_NAME}:alpine
    container_name: ${NEXT_CONTAINER_NAME}
    env_file: [.env]
    environment:
      - SENTRY_AUTH_TOKEN
      - NEXT_PUBLIC_SITE_URL
      - NEXT_PUBLIC_CONVEX_URL
      - NEXT_PUBLIC_PLAUSIBLE_URL
      - NEXT_PUBLIC_SENTRY_DSN
      - NEXT_PUBLIC_SENTRY_URL
      - NEXT_PUBLIC_SENTRY_ORG
      - NEXT_PUBLIC_SENTRY_PROJECT_NAME
    hostname: ${NEXT_CONTAINER_NAME}
    domainname: ${NEXT_DOMAIN_NAME}
    networks: ['${NETWORK:-nginx-bridge}']
    #ports: ['${NEXT_PORT}:3000']
    depends_on: ['convex-backend']
    tty: true
    stdin_open: true
    restart: unless-stopped

  convex-backend:
    image: ghcr.io/get-convex/convex-backend:${BACKEND_TAG:-latest}
    container_name: ${BACKEND_CONTAINER_NAME:-convex-backend}
    hostname: ${BACKEND_CONTAINER_NAME:-convex-backend}
    domainname: ${BACKEND_DOMAIN_NAME:-convex.gbrown.org}
    networks: ['${NETWORK:-nginx-bridge}']
    #user: '1000:1000'
    #ports: ['${BACKEND_PORT:-3210}:3210','${SITE_PROXY_PORT:-3211}:3211']
    volumes: [./data:/convex/data]
    labels: ['com.centurylinklabs.watchtower.enable=true']
    env_file: ['.env']
    environment:
      - INSTANCE_NAME
      - INSTANCE_SECRET
      - CONVEX_CLOUD_ORIGIN=${CONVEX_CLOUD_ORIGIN:-http://${BACKEND_CONTAINER_NAME:-convex-backend}:${BACKEND_PORT:-3210}}
      - CONVEX_SITE_ORIGIN=${CONVEX_SITE_ORIGIN:-http://${BACKEND_CONTAINER_NAME:-convex-backend}:${SITE_PROXY_PORT:-3211}}
      - DISABLE_BEACON
      - REDACT_LOGS_TO_CLIENT
      - DO_NOT_REQUIRE_SSL
      #- DATABASE_URL=${DATABASE_URL:-}
    stdin_open: true
    tty: true
    restart: unless-stopped
    healthcheck:
      test: curl -f http://localhost:3210/version
      interval: 5s
      start_period: 10s
    stop_grace_period: 10s
    stop_signal: SIGINT

  convex-dashboard:
    image: ghcr.io/get-convex/convex-dashboard:${DASHBOARD_TAG:-latest}
    container_name: ${DASHBOARD_CONTAINER_NAME:-convex-dashboard}
    hostname: ${DASHBOARD_CONTAINER_NAME:-convex-dashboard}
    domainname: ${DASHBOARD_DOMAIN_NAME:-dashboard.${BACKEND_DOMAIN_NAME:-convex.gbrown.org}}
    networks: ['${NETWORK:-nginx-bridge}']
    #user: 1000:1000
    #ports: ['${DASHBOARD_PORT:-6791}:6791']
    labels: ['com.centurylinklabs.watchtower.enable=true']
    env_file: [.env]
    environment:
      - NEXT_PUBLIC_DEPLOYMENT_URL=${NEXT_PUBLIC_DEPLOYMENT_URL:-http://${BACKEND_CONTAINER_NAME:-convex-backend}:${PORT:-3210}}
    depends_on:
      convex-backend:
        condition: service_healthy
    stdin_open: true
    tty: true
    restart: unless-stopped
    stop_grace_period: 10s
    stop_signal: SIGINT
